#include "sgg/graphics.h"
#include <cmath>
#include "fractals.h"

// Ορισμός παραμέτρων παραθύρου
const int WINDOW_WIDTH = 600;
const int WINDOW_HEIGHT = 700;

/**
 * @brief Κύρια συνάρτηση που εκκινεί το πρόγραμμα.
 *
 * Δημιουργεί το παράθυρο και καθορίζει τη συνάρτηση σχεδίασης για να απεικονιστεί το fractal.
 *
 * @return int Επιστρέφει 0 για επιτυχημένη εκτέλεση.
 */
int main() {
    graphics::createWindow(WINDOW_WIDTH, WINDOW_HEIGHT, "Sierpinski Triangle Fractal");
    //graphics::createWindow(VicsekFractal::windowWidth, VicsekFractal::windowHeight, "");
    // Ορισμός της συνάρτησης σχεδίασης
    //graphics::setDrawFunction(SierpinskiTriangle::draw);
    //graphics::setDrawFunction(SierpinskiCarpet::draw);
    //graphics::setDrawFunction(BarnsleyFern::draw);
    //graphics::setDrawFunction(DragonCurve::draw);
    //graphics::setDrawFunction(CantorSet::draw);
    //graphics::setDrawFunction(ApollonianGasket::draw);
    //graphics::setDrawFunction(PeanoCurve::draw);
    //graphics::setDrawFunction(HilbertCurve::draw);
    //graphics::setDrawFunction(TSquare::draw);
    //graphics::setDrawFunction(HFractal::draw);
    //graphics::setDrawFunction(VicsekFractal::draw);
    //graphics::setDrawFunction(MengerSponge::draw);
    //graphics::setDrawFunction(Hexaflake::draw);
    //graphics::setDrawFunction(GosperCurve::draw);
    //graphics::setDrawFunction(LevyCCurve::draw);
    //graphics::setDrawFunction(Pentaflake::draw);
    //graphics::setDrawFunction(GoldenDragon::draw);
    //graphics::setDrawFunction(ButterflyFractal::draw);
    //graphics::setDrawFunction(PlasmaFractal::draw);
    //graphics::setDrawFunction(OctahedronFractal::draw);
    //graphics::setDrawFunction(SnowflakeCurve::draw);
    //graphics::setDrawFunction(LSystemFractal::draw);
    //graphics::setDrawFunction(VortexFractal::draw);
    //graphics::setDrawFunction(DurerPentagonFractal::draw);
    //graphics::setDrawFunction(BarnsleyFernFractal::draw);
    //graphics::setDrawFunction(SierpinskiHexagonFractal::draw);
    //graphics::setDrawFunction(CrystalGrowthFractal::draw);
    //graphics::setDrawFunction(FractalHands::draw);
    //graphics::setDrawFunction(FractalMountains::draw);
    //graphics::setDrawFunction(PentagonFractal::draw);
    //graphics::setDrawFunction(ThueMorseCurve::draw);
    //graphics::setDrawFunction(JellyfishFractal::draw);
    //graphics::setDrawFunction(GosperIslandFractal::draw);
    //graphics::setDrawFunction(PentadendriteFractal::draw);
    //graphics::setDrawFunction(PinwheelTilingFractal::draw);
    //graphics::setDrawFunction(VicsekCrossFractal::draw);
    //graphics::setDrawFunction(HexagonTilingFractal::draw);
    //graphics::setDrawFunction(SquareFractal::draw);
    //graphics::setDrawFunction(CarpetFractal::draw);
    //graphics::setDrawFunction(CirclePackingFractal::draw);
    //graphics::setDrawFunction(HTreeFractal::draw);
    //graphics::setDrawFunction(GasketOfTrianglesFractal::draw);
    //graphics::setDrawFunction(ZenoParadoxFractal::draw);
    //graphics::setDrawFunction(CarpetTilingFractal::draw);
    //graphics::setDrawFunction(IceFractal::draw);
    //graphics::setDrawFunction(ArchimedesSpiralFractal::draw);
    //graphics::setDrawFunction(CubicFractal::draw);
    //graphics::setDrawFunction(TorusKnotFractal::draw);
    //graphics::setDrawFunction(KnotTheoryFractal::draw);
    //graphics::setDrawFunction(ButterflyEffectFractal::draw);
    
    //LorenzAttractorFractal::calculateLorenzAttractor();
    //graphics::setDrawFunction(LorenzAttractorFractal::draw);

    //graphics::setDrawFunction(RingFractal::draw);
    //graphics::setDrawFunction(PythagoreanTreeFractal::draw);
    //graphics::setDrawFunction(FlowerFractal::draw);
    //graphics::setDrawFunction(CrystalFractal::draw);
    //graphics::setDrawFunction(FibonacciSpiralFractal::draw);
    //graphics::setDrawFunction(TriangularSpiralFractal::draw);
    //graphics::setDrawFunction(BinaryTreeFractal::draw);
   

    // Έναρξη του κύκλου μηνυμάτων
    graphics::startMessageLoop();
    return 0;
}
